
// -----------------------------------------
// THIS FILE HAS BEEN GENERATED
// DO NOT EDIT MANUALLY
// -----------------------------------------



import { Injectable } from '@angular/core';
import { Observable, of } from 'rxjs';
import { HttpClient, HttpHeaders } from '@angular/common/http';

import { MessageService } from './message.service';
import { serviceBaseUrl } from './config';


import { Account } from './data-objects';
import { Tenant } from './data-objects';
import { Premise } from './data-objects';
import { Flat } from './data-objects';
import { OverheadAdvance } from './data-objects';
import { OverheadAdvanceFlatMapping } from './data-objects';
import { Parking } from './data-objects';
import { CommercialPremise } from './data-objects';
import { Tenancy } from './data-objects';
import { Fee } from './data-objects';
import { TenancyFeeMapping } from './data-objects';
import { AccountEntry } from './data-objects';








@Injectable({ providedIn: 'root' })
export class AccountService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getAccounts(): Promise<Account[]> {
    this.messageService.add(`AccountService: fetch data`);
    return this.http.get<Account[]>(`${serviceBaseUrl}/v1/accounts`).toPromise()
  }

  async getAccount(id: number): Promise<Account> {
    this.messageService.add(`AccountService: fetch data for ${id}`);
    return this.http.get<Account>(`${serviceBaseUrl}/v1/accounts/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class TenantService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getTenants(): Promise<Tenant[]> {
    this.messageService.add(`TenantService: fetch data`);
    return this.http.get<Tenant[]>(`${serviceBaseUrl}/v1/tenants`).toPromise()
  }

  async getTenant(id: number): Promise<Tenant> {
    this.messageService.add(`TenantService: fetch data for ${id}`);
    return this.http.get<Tenant>(`${serviceBaseUrl}/v1/tenants/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class PremiseService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getPremises(): Promise<Premise[]> {
    this.messageService.add(`PremiseService: fetch data`);
    return this.http.get<Premise[]>(`${serviceBaseUrl}/v1/premises`).toPromise()
  }

  async getPremise(id: number): Promise<Premise> {
    this.messageService.add(`PremiseService: fetch data for ${id}`);
    return this.http.get<Premise>(`${serviceBaseUrl}/v1/premises/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class FlatService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getFlats(): Promise<Flat[]> {
    this.messageService.add(`FlatService: fetch data`);
    return this.http.get<Flat[]>(`${serviceBaseUrl}/v1/flats`).toPromise()
  }

  async getFlat(id: number): Promise<Flat> {
    this.messageService.add(`FlatService: fetch data for ${id}`);
    return this.http.get<Flat>(`${serviceBaseUrl}/v1/flats/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class OverheadAdvanceService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getOverheadAdvances(): Promise<OverheadAdvance[]> {
    this.messageService.add(`OverheadAdvanceService: fetch data`);
    return this.http.get<OverheadAdvance[]>(`${serviceBaseUrl}/v1/overhead_advances`).toPromise()
  }

  async getOverheadAdvance(id: number): Promise<OverheadAdvance> {
    this.messageService.add(`OverheadAdvanceService: fetch data for ${id}`);
    return this.http.get<OverheadAdvance>(`${serviceBaseUrl}/v1/overhead_advances/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class OverheadAdvanceFlatMappingService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getOverheadAdvanceFlatMappings(): Promise<OverheadAdvanceFlatMapping[]> {
    this.messageService.add(`OverheadAdvanceFlatMappingService: fetch data`);
    return this.http.get<OverheadAdvanceFlatMapping[]>(`${serviceBaseUrl}/v1/overhead_advance_flat_mappings`).toPromise()
  }

  async getOverheadAdvanceFlatMapping(id: number): Promise<OverheadAdvanceFlatMapping> {
    this.messageService.add(`OverheadAdvanceFlatMappingService: fetch data for ${id}`);
    return this.http.get<OverheadAdvanceFlatMapping>(`${serviceBaseUrl}/v1/overhead_advance_flat_mappings/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class ParkingService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getParkings(): Promise<Parking[]> {
    this.messageService.add(`ParkingService: fetch data`);
    return this.http.get<Parking[]>(`${serviceBaseUrl}/v1/parkings`).toPromise()
  }

  async getParking(id: number): Promise<Parking> {
    this.messageService.add(`ParkingService: fetch data for ${id}`);
    return this.http.get<Parking>(`${serviceBaseUrl}/v1/parkings/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class CommercialPremiseService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getCommercialPremises(): Promise<CommercialPremise[]> {
    this.messageService.add(`CommercialPremiseService: fetch data`);
    return this.http.get<CommercialPremise[]>(`${serviceBaseUrl}/v1/commercial_premises`).toPromise()
  }

  async getCommercialPremise(id: number): Promise<CommercialPremise> {
    this.messageService.add(`CommercialPremiseService: fetch data for ${id}`);
    return this.http.get<CommercialPremise>(`${serviceBaseUrl}/v1/commercial_premises/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class TenancyService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getTenancys(): Promise<Tenancy[]> {
    this.messageService.add(`TenancyService: fetch data`);
    return this.http.get<Tenancy[]>(`${serviceBaseUrl}/v1/tenancys`).toPromise()
  }

  async getTenancy(id: number): Promise<Tenancy> {
    this.messageService.add(`TenancyService: fetch data for ${id}`);
    return this.http.get<Tenancy>(`${serviceBaseUrl}/v1/tenancys/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class FeeService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getFees(): Promise<Fee[]> {
    this.messageService.add(`FeeService: fetch data`);
    return this.http.get<Fee[]>(`${serviceBaseUrl}/v1/fees`).toPromise()
  }

  async getFee(id: number): Promise<Fee> {
    this.messageService.add(`FeeService: fetch data for ${id}`);
    return this.http.get<Fee>(`${serviceBaseUrl}/v1/fees/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class TenancyFeeMappingService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getTenancyFeeMappings(): Promise<TenancyFeeMapping[]> {
    this.messageService.add(`TenancyFeeMappingService: fetch data`);
    return this.http.get<TenancyFeeMapping[]>(`${serviceBaseUrl}/v1/tenancy_fee_mappings`).toPromise()
  }

  async getTenancyFeeMapping(id: number): Promise<TenancyFeeMapping> {
    this.messageService.add(`TenancyFeeMappingService: fetch data for ${id}`);
    return this.http.get<TenancyFeeMapping>(`${serviceBaseUrl}/v1/tenancy_fee_mappings/${id}`).toPromise()
  }

}

@Injectable({ providedIn: 'root' })
export class AccountEntryService {
  constructor(private messageService: MessageService, private http: HttpClient) { }
  
  async getAccountEntrys(): Promise<AccountEntry[]> {
    this.messageService.add(`AccountEntryService: fetch data`);
    return this.http.get<AccountEntry[]>(`${serviceBaseUrl}/v1/account_entrys`).toPromise()
  }

  async getAccountEntry(id: number): Promise<AccountEntry> {
    this.messageService.add(`AccountEntryService: fetch data for ${id}`);
    return this.http.get<AccountEntry>(`${serviceBaseUrl}/v1/account_entrys/${id}`).toPromise()
  }

}


