import { Component, OnInit } from '@angular/core';
import { MessageService } from '../message.service';
import { ParkingService } from '../data-object-service';
import { Parking } from '../data-objects';
import { MatTableDataSource } from '@angular/material/table'

@Component({
  selector: 'app-my-parkings',
  templateUrl: './my-parkings.component.html',
  styleUrls: ['./my-parkings.component.css']
})
export class MyParkingsComponent implements OnInit {

  parkings: Parking[]
  dataSource: MatTableDataSource<Parking>
  displayedColumns: string[] = ["description", "premise"]

  constructor(private parkingService: ParkingService, private messageService: MessageService) { }

  async getParkings(): Promise<void> {
    try {
      this.messageService.add("Trying to load parkings")
      this.parkings = await this.parkingService.getParkings()
      this.messageService.add("Parkings loaded")

      this.dataSource = new MatTableDataSource<Parking>(this.parkings)
    } catch (err) {
      this.messageService.add(JSON.stringify(err, undefined, 4))
    }
  }

  ngOnInit(): void {
    this.messageService.add("MyParkingsComponent.ngOnInit")
    this.getParkings()
  }

}
